]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
2c308a27b373ec1b35e8480d6a8d0e9db140d14a
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.1" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake backup
322 ipfiremake dhcp
323 ipfiremake dhcpcd
324 ipfiremake libusb
325 ipfiremake libpcap
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake zaptel SMP=1
332 ipfiremake linux
333 ipfiremake ipp2p
334 ipfiremake zaptel
335 ipfiremake pkg-config
336 ipfiremake linux-atm
337 ipfiremake cpio
338 ipfiremake klibc
339 ipfiremake mkinitcpio
340 ipfiremake udev KLIBC=1
341 ipfiremake expat
342 ipfiremake gdbm
343 ipfiremake gmp
344 ipfiremake pam
345 ipfiremake openssl
346 ipfiremake curl
347 ipfiremake python
348 ipfiremake libnet
349 ipfiremake libidn
350 ipfiremake libjpeg
351 ipfiremake libpng
352 ipfiremake libtiff
353 ipfiremake libart
354 ipfiremake freetype
355 ipfiremake gd
356 ipfiremake popt
357 ipfiremake pcre
358 ipfiremake slang
359 ipfiremake newt
360 ipfiremake libcap
361 ipfiremake pciutils
362 ipfiremake usbutils
363 ipfiremake libxml2
364 ipfiremake libxslt
365 ipfiremake BerkeleyDB
366 ipfiremake mysql
367 ipfiremake cyrus-sasl
368 ipfiremake openldap
369 ipfiremake apache2
370 ipfiremake php
371 ipfiremake apache2 PASS=C
372 ipfiremake arping
373 ipfiremake beep
374 ipfiremake bind
375 ipfiremake cdrtools
376 ipfiremake dnsmasq
377 ipfiremake dosfstools
378 ipfiremake squashfstools
379 ipfiremake reiserfsprogs
380 ipfiremake xfsprogs
381 ipfiremake sysfsutils
382 ipfiremake fuse
383 ipfiremake ntfs-3g
384 ipfiremake ethtool
385 ipfiremake ez-ipupdate
386 ipfiremake fcron
387 ipfiremake perl-GD
388 ipfiremake GD-Graph
389 ipfiremake GD-TextUtil
390 ipfiremake gnupg
391 ipfiremake hdparm
392 ipfiremake sdparm
393 ipfiremake mtools
394 ipfiremake initscripts
395 ipfiremake whatmask
396 ipfiremake iptables
397 ipfiremake libupnp
398 ipfiremake ipp2p IPT=1
399 ipfiremake linux-igd
400 ipfiremake ipac-ng
401 ipfiremake ipaddr
402 ipfiremake iptstate
403 ipfiremake iputils
404 ipfiremake l7-protocols
405 ipfiremake mISDN
406 ipfiremake hwdata
407 ipfiremake kudzu
408 ipfiremake logrotate
409 ipfiremake logwatch
410 ipfiremake misc-progs
411 ipfiremake nano
412 ipfiremake nasm
413 ipfiremake URI
414 ipfiremake HTML-Tagset
415 ipfiremake HTML-Parser
416 ipfiremake Compress-Zlib
417 ipfiremake Digest
418 ipfiremake Digest-SHA1
419 ipfiremake Digest-HMAC
420 ipfiremake libwww-perl
421 ipfiremake Net-DNS
422 ipfiremake Net-IPv4Addr
423 ipfiremake Net_SSLeay
424 ipfiremake IO-Stringy
425 ipfiremake Unix-Syslog
426 ipfiremake Mail-Tools
427 ipfiremake MIME-Tools
428 ipfiremake Net-Server
429 ipfiremake Convert-TNEF
430 ipfiremake Convert-UUlib
431 ipfiremake Archive-Tar
432 ipfiremake Archive-Zip
433 ipfiremake Text-Tabs+Wrap
434 ipfiremake Locale-Country
435 ipfiremake XML-Parser
436 ipfiremake glib
437 ipfiremake GeoIP
438 ipfiremake fwhits
439 ipfiremake noip_updater
440 ipfiremake ntp
441 ipfiremake openssh
442 ipfiremake openswan
443 ipfiremake rrdtool
444 ipfiremake setserial
445 ipfiremake setup
446 ipfiremake snort
447 ipfiremake oinkmaster
448 ipfiremake squid
449 ipfiremake squid-graph
450 ipfiremake squidguard
451 ipfiremake calamaris
452 ipfiremake tcpdump
453 ipfiremake traceroute
454 ipfiremake vlan
455 ipfiremake wireless
456 ipfiremake libsafe
457 ipfiremake pakfire
458 ipfiremake java
459 ipfiremake spandsp
460 ipfiremake lzo
461 ipfiremake openvpn
462 ipfiremake pammysql
463 ipfiremake cups
464 ipfiremake ghostscript
465 ipfiremake foomatic
466 ipfiremake hplip
467 ipfiremake samba
468 ipfiremake sudo
469 ipfiremake mc
470 ipfiremake wget
471 ipfiremake bridge-utils
472 ipfiremake screen
473 ipfiremake hddtemp
474 ipfiremake smartmontools
475 ipfiremake htop
476 ipfiremake postfix
477 ipfiremake fetchmail
478 ipfiremake cyrus-imapd
479 ipfiremake openmailadmin
480 ipfiremake clamav
481 ipfiremake spamassassin
482 ipfiremake amavisd
483 ipfiremake alsa
484 ipfiremake mpg123
485 ipfiremake mpfire
486 ipfiremake guardian
487 ipfiremake libid3tag
488 ipfiremake libmad
489 ipfiremake libogg
490 ipfiremake libvorbis
491 ipfiremake lame
492 ipfiremake sox
493 ipfiremake libshout
494 ipfiremake icecast
495 ipfiremake icegenerator
496 ipfiremake mpd
497 ipfiremake mpc
498 ipfiremake xvid
499 ipfiremake libmpeg2
500 ipfiremake videolan
501 ipfiremake libpri
502 ipfiremake asterisk
503 ipfiremake gnump3d
504 ipfiremake libsigc++
505 ipfiremake applejuice
506 ipfiremake ocaml
507 ipfiremake mldonkey
508 ipfiremake libtorrent
509 ipfiremake rtorrent
510 ipfiremake ipfireseeder
511 ipfiremake rsync
512 ipfiremake tcpwrapper
513 ipfiremake portmap
514 ipfiremake nfs
515 ipfiremake nmap
516 ipfiremake mbmon
517 ipfiremake ncftp
518 ipfiremake etherwake
519 ipfiremake bwm-ng
520 ipfiremake tripwire
521 ipfiremake sysstat
522 ipfiremake vsftpd
523 ipfiremake which
524 ipfiremake lsof
525 ipfiremake centerim
526 ipfiremake br2684ctl
527 ipfiremake neon
528 ipfiremake subversion
529 }
530
531 buildinstaller() {
532 # Run installer scripts one by one
533 LOGFILE="$BASEDIR/log/_build.installer.log"
534 export LOGFILE
535 ipfiremake syslinux
536 ipfiremake as86
537 ipfiremake mbr
538 ipfiremake memtest
539 installmake linux-libc-header
540 installmake binutils
541 ipfiremake uClibc PASS=1
542 ipfiremake gcc INST=1
543 installmake uClibc PASS=2
544 installmake gcc INST=2
545 installmake uClibc PASS=3
546 installmake busybox
547 installmake udev
548 installmake slang
549 installmake newt
550 installmake gettext
551 installmake kbd
552 installmake popt
553 installmake sysvinit
554 installmake misc-progs
555 installmake libaal
556 installmake reiser4progs
557 installmake reiserfsprogs
558 installmake sysfsutils
559 installmake util-linux
560 installmake pciutils
561 installmake zlib
562 installmake mtd
563 installmake wget
564 installmake hwdata
565 installmake kudzu
566 installmake installer
567 installmake initrd
568 }
569
570 buildpackages() {
571 LOGFILE="$BASEDIR/log/_build.packages.log"
572 export LOGFILE
573 echo "... see detailed log in _build.*.log files" >> $LOGFILE
574
575 installmake strip
576
577 # Generating list of packages used
578 echo -n "Generating packages list from logs" | tee -a $LOGFILE
579 rm -f $BASEDIR/doc/packages-list
580 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
581 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
582 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
583 fi
584 done
585 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
586 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
587 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
588 rm -f $BASEDIR/doc/packages-list
589 # packages-list.txt is ready to be displayed for wiki page
590 beautify message DONE
591
592 # Create images for install
593 ipfiremake cdrom ED=full
594
595 # Check if there is a loop device for building in virtual environments
596 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
597 ipfiremake usb-stick
598 fi
599 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
600
601 ipfirepackages
602
603 # Cleanup
604 stdumount
605 rm -rf $BASEDIR/build/tmp/*
606
607 # Generating total list of files
608 echo -n "Generating files list from logs" | tee -a $LOGFILE
609 rm -f $BASEDIR/log/FILES
610 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
611 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
612 echo "##" >>$BASEDIR/log/FILES
613 echo "## `basename $i`" >>$BASEDIR/log/FILES
614 echo "##" >>$BASEDIR/log/FILES
615 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
616 fi
617 done
618 beautify message DONE
619
620 cd $PWD
621 }
622
623 ipfirepackages() {
624 ipfiremake core-updates
625 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
626 if [ -e $BASEDIR/lfs/$i ]; then
627 ipfiredist $i
628 else
629 echo -n $i
630 beautify message SKIP
631 fi
632 done
633 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
634 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
635 rm -rf $BASEDIR/build/install/packages/*
636 }
637
638 # See what we're supposed to do
639 case "$1" in
640 build)
641 clear
642 BUILDMACHINE=`uname -m`
643 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
644 #only restore on a clean disk
645 if [ ! -f log/cleanup-toolchain-2-tools ]; then
646 if [ ! -n "$PACKAGE" ]; then
647 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
648 prepareenv
649 buildtoolchain
650 else
651 PACKAGENAME=${PACKAGE%.tar.gz}
652 beautify build_stage "Packaged toolchain compilation"
653 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
654 tar zxf $PACKAGE
655 prepareenv
656 else
657 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
658 fi
659 fi
660 else
661 echo -n "Using installed toolchain" | tee -a $LOGFILE
662 beautify message SKIP
663 prepareenv
664 fi
665
666 beautify build_start
667 beautify build_stage "Building LFS"
668 buildbase
669
670 beautify build_stage "Building IPFire"
671 buildipfire
672
673 # Setzen des IPFire Builds
674 if [ "$FIREBUILD" ]; then
675 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
676 else
677 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
678 fi
679
680 beautify build_stage "Building installer"
681 buildinstaller
682
683 beautify build_stage "Building packages"
684 buildpackages
685 beautify build_end
686 ;;
687 shell)
688 # enter a shell inside LFS chroot
689 # may be used to changed kernel settings
690 prepareenv
691 entershell
692 ;;
693 changelog)
694 echo -n "Loading new Changelog from SVN: "
695 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
696 beautify message DONE
697 ;;
698 clean)
699 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
700 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
701 $LOSETUP -d $i 2>/dev/null
702 done
703 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
704 umount $i
705 done
706 stdumount
707 for i in `seq 0 7`; do
708 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
709 umount /dev/loop${i} 2>/dev/null;
710 losetup -d /dev/loop${i} 2>/dev/null;
711 fi;
712 done
713 rm -rf $BASEDIR/build
714 rm -rf $BASEDIR/cdrom
715 rm -rf $BASEDIR/packages
716 rm -rf $BASEDIR/log
717 if [ -h /tools ]; then
718 rm -f /tools
719 fi
720 beautify message DONE
721 ;;
722 downloadsrc)
723 if [ ! -d $BASEDIR/cache ]; then
724 mkdir $BASEDIR/cache
725 fi
726 mkdir -p $BASEDIR/log
727 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
728 FINISHED=0
729 cd $BASEDIR/lfs
730 for c in `seq $MAX_RETRIES`; do
731 if (( FINISHED==1 )); then
732 break
733 fi
734 FINISHED=1
735 cd $BASEDIR/lfs
736 for i in *; do
737 if [ -f "$i" -a "$i" != "Config" ]; then
738 echo -ne "Loading $i"
739 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
740 if [ $? -ne 0 ]; then
741 beautify message FAIL
742 FINISHED=0
743 else
744 if [ $c -eq 1 ]; then
745 beautify message DONE
746 fi
747 fi
748 fi
749 done
750 done
751 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
752 ERROR=0
753 for i in *; do
754 if [ -f "$i" -a "$i" != "Config" ]; then
755 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
756 if [ $? -ne 0 ]; then
757 echo -ne "MD5 difference in lfs/$i"
758 beautify message FAIL
759 ERROR=1
760 fi
761 fi
762 done
763 if [ $ERROR -eq 0 ]; then
764 echo -ne "${BOLD}all files md5sum match${NORMAL}"
765 beautify message DONE
766 else
767 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
768 beautify message FAIL
769 fi
770 cd - >/dev/null 2>&1
771 ;;
772 toolchain)
773 clear
774 prepareenv
775 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
776 buildtoolchain
777 BUILDMACHINE=`uname -m`
778 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
779 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
780 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
781 build/{bin,etc,usr/bin,usr/local} \
782 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
783 log >> $LOGFILE
784 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
785 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
786 stdumount
787 ;;
788 gettoolchain)
789 BUILDMACHINE=`uname -m`
790 # arbitrary name to be updated in case of new toolchain package upload
791 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
792 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
793 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
794 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
795 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
796 cd $BASEDIR/cache/toolchains
797 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
798 if [ $? -ne 0 ]; then
799 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
800 else
801 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
802 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
803 else
804 exiterror "$PACKAGE.md5 did not match, check downloaded package"
805 fi
806 fi
807 else
808 echo "Toolchain is already downloaded. Exiting..."
809 fi
810 ;;
811 othersrc)
812 prepareenv
813 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
814 chroot $LFS /tools/bin/env -i HOME=/root \
815 TERM=$TERM PS1='\u:\w\$ ' \
816 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
817 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
818 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
819 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
820 if [ $? -eq "0" ]; then
821 beautify message DONE
822 else
823 beautify message FAIL
824 fi
825 stdumount
826 ;;
827 svn)
828 case "$2" in
829 update|up)
830 # clear
831 echo -ne "Loading the latest source files...\n"
832 if [ $3 ]; then
833 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
834 else
835 svn update | tee -a $PWD/log/_build.svn.update.log
836 fi
837 if [ $? -eq "0" ]; then
838 beautify message DONE
839 else
840 beautify message FAIL
841 exit 1
842 fi
843 echo -ne "Writing the svn-info to a file"
844 svn info > $PWD/svn_status
845 if [ $? -eq "0" ]; then
846 beautify message DONE
847 else
848 beautify message FAIL
849 exit 1
850 fi
851 chmod 755 $0
852 exit 0
853 ;;
854 commit|ci)
855 clear
856 if [ -f /usr/bin/mcedit ]; then
857 export EDITOR=/usr/bin/mcedit
858 fi
859 if [ -f /usr/bin/nano ]; then
860 export EDITOR=/usr/bin/nano
861 fi
862 echo -ne "Selecting editor $EDITOR..."
863 beautify message DONE
864 if [ -e /sbin/yast ]; then
865 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
866 $0 changelog
867 fi
868 fi
869 update_langs
870 svn commit
871 $0 svn up
872 if [ -n "$FTP_CACHE_URL" ]; then
873 $0 uploadsrc
874 fi
875 ;;
876 dist)
877 if [ $3 ]; then
878 SVN_REVISION=$3
879 fi
880 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
881 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
882 exit 0
883 fi
884 echo -en "REV $SVN_REVISION: Downloading..."
885 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
886 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
887 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
888 evaluate 1
889
890 echo -en "REV $SVN_REVISION: Compressing files..."
891 if [ -e ipfire-source/trunk/make.sh ]; then
892 chmod 755 ipfire-source/trunk/make.sh
893 fi
894 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
895 evaluate 1
896 echo -en "REV $SVN_REVISION: Cleaning up..."
897 rm ipfire-source/ -r
898 evaluate 1
899 ;;
900 diff|di)
901 update_langs
902 echo -ne "Make a local diff to last svn revision"
903 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
904 evaluate 1
905 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
906 svn status
907 ;;
908 esac
909 ;;
910 uploadsrc)
911 PWD=`pwd`
912 cd $BASEDIR/cache/
913 echo -e "Uploading cache to ftp server:"
914 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
915 for i in *; do
916 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
917 grep -q $(basename $i) /tmp/ftplist
918 if [ "$?" -ne "0" ]; then
919 echo -ne "$(basename $i)"
920 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
921 if [ "$?" -ne "0" ]; then
922 beautify message FAIL
923 fi
924 fi
925 done
926 rm -f /tmp/ftplist
927 cd $PWD
928 exit 0
929 ;;
930 upload)
931 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
932 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
933 if [ -z $FTP_ISO_PORT ]; then
934 FTP_ISO_PORT=21
935 fi
936 cat <<EOF > .ftp-commands
937 mkdir -p $FTP_ISO_PATH$SVN_REVISION
938 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
939 quit
940 EOF
941 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
942 rm -f .ftp-commands
943
944 case "$2" in
945 iso)
946 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
947
948 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
949 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
950 if [ -e "$i" ]; then
951 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
952 if [ "$?" -eq "0" ]; then
953 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
954 else
955 echo "There was an error while uploading the file $i to the ftp server."
956 exit 1
957 fi
958 fi
959 done
960 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
961 if [ "$3" = "--with-sources-cd" ]; then
962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
963 fi
964 ;;
965 paks)
966 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
967 if [ "$?" -eq "0" ]; then
968 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
969 else
970 echo -e "There was an error while uploading the packages to the ftp server."
971 exit 1
972 fi
973 ;;
974 esac
975 ;;
976 batch)
977 if [ "$2" = "--background" ]; then
978 batch_script
979 exit $?
980 fi
981 if [ `screen -ls | grep -q ipfire` ]; then
982 echo "Build is already running, sorry!"
983 exit 1
984 else
985 if [ "$2" = "--rebuild" ]; then
986 export IPFIRE_REBUILD=1
987 echo "REBUILD!"
988 else
989 export IPFIRE_REBUILD=0
990 fi
991 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
992 screen -dmS ipfire $0 batch --background
993 evaluate 1
994 exit 0
995 fi
996 ;;
997 watch)
998 watch_screen
999 ;;
1000 pxe)
1001 case "$2" in
1002 start)
1003 start_tftpd
1004 ;;
1005 stop)
1006 stop_tftpd
1007 ;;
1008 reload|restart)
1009 reload_tftpd
1010 ;;
1011 esac
1012 exit 0
1013 ;;
1014 lang)
1015 update_langs
1016 ;;
1017 "")
1018 clear
1019 svn info
1020 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1021 do
1022 case $name in
1023 "IPFIRE: Downloadsrc")
1024 $0 downloadsrc
1025 ;;
1026 "IPFIRE: Build (silent)")
1027 $0 build-silent
1028 ;;
1029 "IPFIRE: Watch Build")
1030 $0 watch
1031 ;;
1032 "IPFIRE: Batch")
1033 $0 batch
1034 ;;
1035 "IPFIRE: Clean")
1036 $0 clean
1037 ;;
1038 "SVN: Update")
1039 $0 svn update
1040 ;;
1041 "Help")
1042 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1043 cat doc/make.sh-usage
1044 ;;
1045 "LOG: Tail")
1046 tail -f log/_*
1047 ;;
1048 "Exit")
1049 break
1050 ;;
1051 esac
1052 done
1053 ;;
1054 config)
1055 make_config
1056 ;;
1057 *)
1058 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1059 cat doc/make.sh-usage
1060 ;;
1061 esac